#	Makefile for DOS & TCC

CC=	tcc
TC=	command /e:2048 /c ..\build\tc

default:	txtrn.exe ux.exe txx.exe txopt.exe txpp.exe \
	txinfo.exe

txtrn.exe:	txtrn.t
	$(TC) txtrn

ux.exe:	ux.t
	$(TC) ux

txx.exe:	txx.c lib.c txx_ext.h
	$(CC) -Dmsdos -DBASIC_EXT -ml -etxx.exe txx.c lib.c

txopt.exe:	txopt.t
	$(TC) txopt

txpp.exe:	txpp.t
	$(TC) txpp

txinfo.exe:	txinfo.t
	$(TC) txinfo

diff:
	.\txtrn <txtrn.t >__stage1
	.\txx __stage1 <txtrn.t >__stage2
	comp __stage1 __stage2
	-del __stage1
	-del __stage2

hotdiff:
	.\txtrn <txtrn.t >__txtrn.UOP
	.\txopt <__txtrn.UOP >__txtrn
	.\txtrn <txopt.t >__txopt.UOP
	.\txopt <__txopt.UOP >__txopt
	.\txx __txtrn < txtrn.t > __txtrn2.UOP
	.\txx __txopt <__txtrn2.UOP >__txtrn2
	comp __txtrn.UOP __txtrn2.UOP
	comp __txtrn __txtrn2
	-del __txtrn.UOP
	-del __txtrn
	-del __txtrn2.UOP
	-del __txtrn2
	-del __txopt.UOP
	-del __txopt

clean:
	-del *.ERR
	-del *.obj

clobber:	clean
	-del txtrn.exe
	-del ux.exe
	-del txx.exe
	-del txopt.exe
	-del txpp.exe
	-del txinfo.exe
